From 9f804f7a003d00771304af6f0f4f96a9839571f3 Mon Sep 17 00:00:00 2001
From: Ashutosh Bapat <ashutosh.bapat.oss@gmail.com>
Date: Fri, 26 Sep 2025 19:12:45 +0530
Subject: [PATCH 18/19] Re-implement UI and synchronization for resizing buffer
 pool

shared_buffers is not PGC_SIGHUP instead of PGC_POSTMASTER.  The value
of this GUC is saved in NBuffersPending instead of NBuffers which now
shows the size of buffer pool in-effect. When the server starts, the
shared memory size is estimated and the memory is allocated using
NBuffersPending followed by setting NBuffers = NBuffersPending.

When a server is running, the new value of GUC (set using ALTER SYSTEM
... SET shared_buffers = ...; followed by SELECT pg_reload_conf()) does
not come into effect immediately. Instead a function
pg_resize_shared_buffers() is used to resize the buffer pool. The
function uses the current value of GUC in the backends where it is
executed. The function also coordinates the buffer resizing
synchronization across backends.

SHOW shared_buffers now shows the current size of the shared buffers but
it also shows pending size of shared buffers, if any.

A new GUC max_shared_buffers is introduced to control the maximum value
of shared_buffers that can be set. By default it is 0 and it is set to
shared_buffers' value. When explicitly set it needs to be higher than
'shared_buffers'. This GUC determines the size of address space reserved
for future buffer pool sizes and the size of buffer look up table.

TODO: In case the backend executing pg_resize_shared_buffers() exits
before the operation finishes, we will need somebody to clean up or
complete the half-finished resizing operation. Best possibility is to
use a background worker (mostly background writer) to do that. But then
I think making that background worker the coordinator itself might be a
better option since it will be restarted by the postmaster upon
premature exit.

Author: Ashutosh Bapat <ashutosh.bapat.oss@gmail.com>
---
 doc/src/sgml/config.sgml                      |  44 +-
 doc/src/sgml/func/func-admin.sgml             |  57 ++
 src/backend/access/transam/slru.c             |   2 +-
 src/backend/access/transam/xlog.c             |   2 +-
 src/backend/bootstrap/bootstrap.c             |   2 +
 src/backend/port/sysv_shmem.c                 | 433 ++--------------
 src/backend/postmaster/postmaster.c           |  40 +-
 src/backend/storage/buffer/buf_init.c         | 264 ++++++++--
 src/backend/storage/buffer/bufmgr.c           | 126 +++--
 src/backend/storage/buffer/freelist.c         | 118 ++---
 src/backend/storage/ipc/ipci.c                |   8 +-
 src/backend/storage/ipc/procsignal.c          |  14 +-
 src/backend/storage/ipc/shmem.c               | 485 +++++++++++++++++-
 src/backend/tcop/postgres.c                   |  13 +-
 .../utils/activity/wait_event_names.txt       |   4 +-
 src/backend/utils/init/globals.c              |   6 +-
 src/backend/utils/init/postinit.c             |  32 ++
 src/backend/utils/misc/guc.c                  |   2 +-
 src/backend/utils/misc/guc_parameters.dat     |  16 +-
 src/include/catalog/pg_proc.dat               |   6 +
 src/include/miscadmin.h                       |   6 +-
 src/include/storage/buf_internals.h           |   2 +-
 src/include/storage/bufmgr.h                  |  17 +-
 src/include/storage/ipc.h                     |   1 -
 src/include/storage/pg_shmem.h                |  24 +-
 src/include/storage/procsignal.h              |   5 +-
 src/include/storage/shmem.h                   |   8 +
 src/include/utils/guc.h                       |   2 +
 src/test/buffermgr/Makefile                   |   3 +
 src/test/buffermgr/buffermgr_test.conf        |   9 +
 src/test/buffermgr/expected/buffer_resize.out | 184 +++++--
 src/test/buffermgr/meson.build                |   5 +
 src/test/buffermgr/sql/buffer_resize.sql      |  44 +-
 src/test/buffermgr/t/001_resize_buffer.pl     |  44 +-
 .../buffermgr/t/003_parallel_resize_buffer.pl |  71 +++
 35 files changed, 1387 insertions(+), 712 deletions(-)
 create mode 100644 src/test/buffermgr/buffermgr_test.conf
 create mode 100644 src/test/buffermgr/t/003_parallel_resize_buffer.pl

diff --git a/doc/src/sgml/config.sgml b/doc/src/sgml/config.sgml
index 39e658b7808..732f9636857 100644
--- a/doc/src/sgml/config.sgml
+++ b/doc/src/sgml/config.sgml
@@ -1724,7 +1724,6 @@ include_dir 'conf.d'
         that is <symbol>BLCKSZ</symbol> bytes, typically 8kB.
         (Non-default values of <symbol>BLCKSZ</symbol> change the minimum
         value.)
-        This parameter can only be set at server start.
        </para>
 
        <para>
@@ -1747,6 +1746,49 @@ include_dir 'conf.d'
         appropriate, so as to leave adequate space for the operating system.
        </para>
 
+       <para>
+        The shared memory consumed by the buffer pool is allocated and
+        initialized according to the value of the GUC at the time of starting
+        the server. A desired new value of GUC can be loaded while the server is
+        running using <systemitem>SIGHUP</systemitem>. But the buffer pool will
+        not be resized immediately. Use
+        <function>pg_resize_shared_buffers()</function> to dynamically resize
+        the shared buffer pool (see <xref linkend="functions-admin"/> for details).
+        <command>SHOW shared_buffers</command> shows the current number of
+        shared buffers and pending number, if any. Please note that when the GUC
+        is changed, the other GUCS which use this GUCs value to set their
+        defaults will not be changed. They may still require a server restart to
+        consider new value.
+       </para>
+      </listitem>
+     </varlistentry>
+
+     <varlistentry id="guc-max-shared-buffers" xreflabel="max_shared_buffers">
+      <term><varname>max_shared_buffers</varname> (<type>integer</type>)
+      <indexterm>
+       <primary><varname>max_shared_buffers</varname> configuration parameter</primary>
+      </indexterm>
+      </term>
+      <listitem>
+       <para>
+        Sets the upper limit for the <varname>shared_buffers</varname> value.
+        The default value is <literal>0</literal>,
+        which means no explicit limit is set and <varname>max_shared_buffers</varname>
+        will be automatically set to the value of <varname>shared_buffers</varname>
+        at server startup.
+        If this value is specified without units, it is taken as blocks,
+        that is <symbol>BLCKSZ</symbol> bytes, typically 8kB.
+        This parameter can only be set at server start.
+       </para>
+
+       <para>
+        This parameter determines the amount of memory address space to reserve
+        in each backend for expanding the buffer pool in future. While the
+        memory for buffer pool is allocated on demand as it is resized, the
+        memory required to hold the buffer manager metadata is allocated
+        statically at the server start accounting for the largest buffer pool
+        size allowed by this parameter.
+       </para>
       </listitem>
      </varlistentry>
 
diff --git a/doc/src/sgml/func/func-admin.sgml b/doc/src/sgml/func/func-admin.sgml
index 1b465bc8ba7..0dc89b07c76 100644
--- a/doc/src/sgml/func/func-admin.sgml
+++ b/doc/src/sgml/func/func-admin.sgml
@@ -99,6 +99,63 @@
         <returnvalue>off</returnvalue>
        </para></entry>
       </row>
+
+      <row>
+       <entry role="func_table_entry"><para role="func_signature">
+        <indexterm>
+         <primary>pg_resize_shared_buffers</primary>
+        </indexterm>
+        <function>pg_resize_shared_buffers</function> ()
+        <returnvalue>boolean</returnvalue>
+       </para>
+       <para>
+        Dynamically resizes the shared buffer pool to match the current
+        value of the <varname>shared_buffers</varname> parameter. This
+        function implements a coordinated resize process that ensures all
+        backend processes acknowledge the change before completing the
+        operation. The resize happens in multiple phases to maintain
+        data consistency and system stability. Returns <literal>true</literal>
+        if the resize was successful, or raises an error if the operation
+        fails. This function can only be called by superusers.
+       </para>
+       <para>
+        To resize shared buffers, first update the <varname>shared_buffers</varname>
+        setting and reload the configuration, then verify the new value is loaded
+        before calling this function. For example:
+<programlisting>
+postgres=# ALTER SYSTEM SET shared_buffers = '256MB';
+ALTER SYSTEM
+postgres=# SELECT pg_reload_conf();
+ pg_reload_conf
+----------------
+ t
+(1 row)
+
+postgres=# SHOW shared_buffers;
+     shared_buffers      
+-------------------------
+ 128MB (pending: 256MB)
+(1 row)
+
+postgres=# SELECT pg_resize_shared_buffers();
+ pg_resize_shared_buffers
+--------------------------
+ t
+(1 row)
+
+postgres=# SHOW shared_buffers;
+ shared_buffers
+----------------
+ 256MB
+(1 row)
+</programlisting>
+        The <command>SHOW shared_buffers</command> step is important to verify
+        that the configuration reload was successful and the new value is
+        available to the current session before attempting the resize. The
+        output shows both the current and pending values when a change is waiting
+        to be applied.
+       </para></entry>
+      </row>
      </tbody>
     </tgroup>
    </table>
diff --git a/src/backend/access/transam/slru.c b/src/backend/access/transam/slru.c
index 5d3fcd62c94..3eae1d0c7e9 100644
--- a/src/backend/access/transam/slru.c
+++ b/src/backend/access/transam/slru.c
@@ -232,7 +232,7 @@ SimpleLruAutotuneBuffers(int divisor, int max)
 {
 	return Min(max - (max % SLRU_BANK_SIZE),
 			   Max(SLRU_BANK_SIZE,
-				   NBuffers / divisor - (NBuffers / divisor) % SLRU_BANK_SIZE));
+				   NBuffersPending / divisor - (NBuffersPending / divisor) % SLRU_BANK_SIZE));
 }
 
 /*
diff --git a/src/backend/access/transam/xlog.c b/src/backend/access/transam/xlog.c
index eceab341255..ea01befe15c 100644
--- a/src/backend/access/transam/xlog.c
+++ b/src/backend/access/transam/xlog.c
@@ -4662,7 +4662,7 @@ XLOGChooseNumBuffers(void)
 {
 	int			xbuffers;
 
-	xbuffers = NBuffers / 32;
+	xbuffers = NBuffersPending / 32;
 	if (xbuffers > (wal_segment_size / XLOG_BLCKSZ))
 		xbuffers = (wal_segment_size / XLOG_BLCKSZ);
 	if (xbuffers < 8)
diff --git a/src/backend/bootstrap/bootstrap.c b/src/backend/bootstrap/bootstrap.c
index fc8638c1b61..226944e4588 100644
--- a/src/backend/bootstrap/bootstrap.c
+++ b/src/backend/bootstrap/bootstrap.c
@@ -335,6 +335,8 @@ BootstrapModeMain(int argc, char *argv[], bool check_only)
 
 	InitializeFastPathLocks();
 
+	InitializeMaxNBuffers();
+
 	CreateSharedMemoryAndSemaphores();
 
 	/*
diff --git a/src/backend/port/sysv_shmem.c b/src/backend/port/sysv_shmem.c
index 3be28e228ae..380ecbc9751 100644
--- a/src/backend/port/sysv_shmem.c
+++ b/src/backend/port/sysv_shmem.c
@@ -102,14 +102,8 @@ void	   *UsedShmemSegAddr = NULL;
 
 AnonymousMapping Mappings[ANON_MAPPINGS];
 
-/* Flag telling postmaster that resize is needed */
-volatile bool pending_pm_shmem_resize = false;
 volatile bool delay_shmem_resize = false;
 
-/* Keeps track of the previous NBuffers value */
-static int NBuffersOld = -1;
-static int NBuffersPending = -1;
-
 /*
  * Anonymous mapping layout we use looks like this:
  *
@@ -137,20 +131,9 @@ static int NBuffersPending = -1;
  * reservation, into which shared memory segment can be extended and is
  * represented by the second /memfd:main with no permissions.
  *
- * The reserved space for each segment is calculated as a fraction of the total
- * reserved space (MaxAvailableMemory), as specified in the SHMEM_RESIZE_RATIO
- * array. E.g. we allow BUFFERS_SHMEM_SEGMENT to take up to 60% of the whole
- * space when resizing, based on the fact that it most likely will be the main
- * consumer of this memory. Those numbers are pulled out of thin air for now,
- * makes sense to evaluate them more precise.
+ * The reserved space for buffer manager related segments is calculated based on
+ * MaxNBuffers.
  */
-static double SHMEM_RESIZE_RATIO[6] = {
-	0.15,    /* MAIN_SHMEM_SEGMENT */
-	0.6,    /* BUFFERS_SHMEM_SEGMENT */
-	0.1,    /* BUFFER_DESCRIPTORS_SHMEM_SEGMENT */
-	0.1,    /* BUFFER_IOCV_SHMEM_SEGMENT */
-	0.05,   /* CHECKPOINT_BUFFERS_SHMEM_SEGMENT */
-};
 
 /*
  * Flag telling that we have decided to use huge pages.
@@ -160,13 +143,6 @@ static double SHMEM_RESIZE_RATIO[6] = {
  */
 static bool huge_pages_on = false;
 
-/*
- * Flag telling that we have prepared the memory layout to be resizable. If
- * false after all shared memory segments creation, it means we failed to setup
- * needed layout and falled back to the regular non-resizable approach.
- */
-static bool shmem_resizable = false;
-
 /*
  * Currently broadcasted value of NBuffers in shared memory.
  *
@@ -791,8 +767,7 @@ CreateAnonymousSegment(AnonymousMapping *mapping)
 		if (mapping->shmem_reserved < mapping->shmem_size)
 			ereport(ERROR,
 					(errcode(ERRCODE_INSUFFICIENT_RESOURCES),
-					 errmsg("not enough shared memory is reserved"),
-					 errhint("You may need to increase \"max_available_memory\".")));
+					 errmsg("not enough shared memory is reserved")));
 
 		mmap_flags = PG_MMAP_FLAGS | mmap_flags;
 	}
@@ -961,36 +936,27 @@ AnonymousShmemDetach(int status, Datum arg)
 }
 
 /*
- * Resize all shared memory segments based on the current NBuffers value, which
- * is is applied from NBuffersPending. The actual segment resizing is done via
- * ftruncate, which will fail if is not sufficient space to expand the anon
- * file. When finished, based on the new and old values initialize new buffer
- * blocks if any.
- *
- * If reinitializing took place, as the last step this function does buffers
- * reinitialization as well and broadcasts the new value of NSharedBuffers. All
- * of that needs to be done only by one backend, the first one that managed to
- * grab the ShmemResizeLock.
+ * Resize all shared memory segments based on the new shared_buffers value (saved
+ * in ShmemCtrl area). The actual segment resizing is done via ftruncate, which
+ * will fail if there is not sufficient space to expand the anon file.
+ * 
+ * TODO: Rename this to BufferShmemResize() or something. Only buffer manager's
+ * memory should be resized in this function.
  */
 bool
 AnonymousShmemResize(void)
 {
-	int		numSemas;
-	bool 	reinit = false;
 	int		mmap_flags = PG_MMAP_FLAGS;
 	Size 	hugepagesize;
 
-	NBuffers = NBuffersPending;
-
-	elog(DEBUG1, "Resize shmem from %d to %d", NBuffersOld, NBuffers);
-
-	/*
-	 * XXX: Where to reset the flag is still an open question. E.g. do we
-	 * consider a no-op when NBuffers is equal to NBuffersOld a genuine resize
-	 * and reset the flag?
-	 */
-	pending_pm_shmem_resize = false;
+	Assert(!pg_atomic_unlocked_test_flag(&ShmemCtrl->resize_in_progress));
 
+	/* TODO: This is a hack. NBuffersPending should never be written by anything
+	 * other than GUC system. Find a way to pass new NBuffers value to
+	 * BufferManagerShmemSize(). */
+	NBuffersPending = pg_atomic_read_u32(&ShmemCtrl->targetNBuffers);
+	elog(DEBUG1, "Resize shmem from %d to %d", NBuffers, NBuffersPending);
+	
 #ifndef MAP_HUGETLB
 	/* PrepareHugePages should have dealt with this case */
 	Assert(huge_pages != HUGE_PAGES_ON && !huge_pages_on);
@@ -1005,8 +971,8 @@ AnonymousShmemResize(void)
 	}
 #endif
 
-	/* Note that CalculateShmemSize indirectly depends on NBuffers */
-	CalculateShmemSize(&numSemas);
+	/* Note that BufferManagerShmemSize() indirectly depends on NBuffersPending. */
+	BufferManagerShmemSize(false);
 
 	for(int i = 0; i < ANON_MAPPINGS; i++)
 	{
@@ -1014,10 +980,18 @@ AnonymousShmemResize(void)
 		ShmemSegment *segment = &Segments[i];
 		PGShmemHeader *shmem_hdr = segment->ShmemSegHdr;
 
+		/* Main shared memory segment is always static. Ignore it. */
+		if (i == MAIN_SHMEM_SEGMENT)
+			continue;
+
+		m->shmem_req_size = add_size(m->shmem_req_size, 8192 - (m->shmem_req_size % 8192));
 #ifdef MAP_HUGETLB
 		if (huge_pages_on && (m->shmem_req_size % hugepagesize != 0))
 			m->shmem_req_size += hugepagesize - (m->shmem_req_size % hugepagesize);
 #endif
+		elog(DEBUG1, "segment[%s]: requested size %zu, current size %zu, reserved %zu",
+			 MappingName(m->shmem_segment), m->shmem_req_size, m->shmem_size,
+			 m->shmem_reserved);
 
 		if (m->shmem == NULL)
 			continue;
@@ -1025,26 +999,28 @@ AnonymousShmemResize(void)
 		if (m->shmem_size == m->shmem_req_size)
 			continue;
 
+		/* We should have reserved enough address space. Also made sure that the
+		 * new size can fit in the existing mapping. PANIC if that's not the
+		 * case. */
 		if (m->shmem_reserved < m->shmem_req_size)
-			ereport(ERROR,
+			ereport(PANIC,
 					(errcode(ERRCODE_INSUFFICIENT_RESOURCES),
-					 errmsg("not enough shared memory is reserved"),
-					 errhint("You may need to increase \"max_available_memory\".")));
+					 errmsg("not enough shared memory is reserved")));
 
 		elog(DEBUG1, "segment[%s]: resize from %zu to %zu at address %p",
 					 MappingName(m->shmem_segment), m->shmem_size,
 					 m->shmem_req_size, m->shmem);
 
-		/* Resize the backing anon file. */
+		/* Resize the backing anon file. If the operation fails, in one backend and we do not know the status in other backends, it will lead to inconsistent buffer manager structures across backends. PANIC. */
 		if(ftruncate(m->segment_fd, m->shmem_req_size) == -1)
-			ereport(FATAL,
+			ereport(PANIC,
 					(errcode(ERRCODE_SYSTEM_ERROR),
 					 errmsg("could not truncase anonymous file for \"%s\": %m",
 							MappingName(m->shmem_segment))));
 
 		/* Adjust memory accessibility */
 		if(mprotect(m->shmem, m->shmem_req_size, PROT_READ | PROT_WRITE) == -1)
-			ereport(FATAL,
+			ereport(PANIC,
 					(errcode(ERRCODE_SYSTEM_ERROR),
 					 errmsg("could not mprotect anonymous shared memory for \"%s\": %m",
 							MappingName(m->shmem_segment))));
@@ -1052,308 +1028,19 @@ AnonymousShmemResize(void)
 		/* If shrinking, make reserved space unavailable again */
 		if(m->shmem_req_size < m->shmem_size &&
 		   mprotect(m->shmem + m->shmem_req_size, m->shmem_size - m->shmem_req_size, PROT_NONE) == -1)
-			ereport(FATAL,
+			ereport(PANIC,
 					(errcode(ERRCODE_SYSTEM_ERROR),
 					 errmsg("could not mprotect reserved shared memory for \"%s\": %m",
 							MappingName(m->shmem_segment))));
 
-		reinit = true;
 		m->shmem_size = m->shmem_req_size;
 		shmem_hdr->totalsize = m->shmem_size;
 		segment->ShmemEnd = m->shmem + m->shmem_size;
 	}
 
-	if (reinit)
-	{
-		if(IsUnderPostmaster &&
-			LWLockConditionalAcquire(ShmemResizeLock, LW_EXCLUSIVE))
-		{
-			/*
-			 * If the new NBuffers was already broadcasted, the buffer pool was
-			 * already initialized before.
-			 *
-			 * Since we're not on a hot path, we use lwlocks and do not need to
-			 * involve memory barrier.
-			 */
-			if(pg_atomic_read_u32(&ShmemCtrl->NSharedBuffers) != NBuffers)
-			{
-				/*
-				 * Allow the first backend that managed to get the lock to
-				 * reinitialize the new portion of buffer pool. Every other
-				 * process will wait on the shared barrier for that to finish,
-				 * since it's a part of the SHMEM_RESIZE_DONE phase.
-				 *
-				 * Note that it's enough when only one backend will do that,
-				 * even the ShmemInitStruct part. The reason is that resized
-				 * shared memory will maintain the same addresses, meaning that
-				 * all the pointers are still valid, and we only need to update
-				 * structures size in the ShmemIndex once -- any other backend
-				 * will pick up this shared structure from the index.
-				 */
-				BufferManagerShmemInit(NBuffersOld);
-
-				/*
-				 * Wipe out the evictor PID so that it can be used for the next
-				 * buffer resizing operation.
-				*/
-				ShmemCtrl->evictor_pid = 0;
-				/* If all fine, broadcast the new value */
-				pg_atomic_write_u32(&ShmemCtrl->NSharedBuffers, NBuffers);
-			}
-
-			LWLockRelease(ShmemResizeLock);
-		}
-	}
-
-	return true;
-}
-
-/*
- * We are asked to resize shared memory. Wait for all ProcSignal participants
- * to join the barrier, then do the resize and wait on the barrier until all
- * participating finish resizing as well -- otherwise we face danger of
- * inconsistency between backends.
- *
- * XXX: If a backend is blocked on ReadCommand in PostgresMain, it will not
- * proceed with AnonymousShmemResize after receiving SIGHUP, until something
- * will be sent.
- */
-bool
-ProcessBarrierShmemResize(Barrier *barrier)
-{
-	Assert(IsUnderPostmaster);
-
-	elog(DEBUG1, "Handle a barrier for shmem resizing from %d to %d, %d, %d",
-		 NBuffersOld, NBuffersPending, pending_pm_shmem_resize, delay_shmem_resize);
-
-	/* Wait until we have seen the new NBuffers value */
-	if (!pending_pm_shmem_resize)
-		return false;
-
-	/* Wait till this process becomes ready to resize buffers. */
-	if (delay_shmem_resize)
-		return false;
-
-	/*
-	 * First thing to do after attaching to the barrier is to wait for others.
-	 * We can't simply use BarrierArriveAndWait, because backends might arrive
-	 * here in disjoint groups, e.g. first two backends, pause, then second two
-	 * backends. If the resize is quick enough that can lead to a situation
-	 * when the first group is already finished before the second has appeared,
-	 * and the barrier will only synchonize withing those groups.
-	 */
-	if (BarrierAttach(barrier) == SHMEM_RESIZE_REQUESTED)
-		WaitForProcSignalBarrierReceived(
-				pg_atomic_read_u64(&ShmemCtrl->Generation));
-
-	/*
-	 * Now start the procedure, and elect one backend to ping postmaster to do
-	 * the same.
-	 *
-	 * XXX: If we need to be able to abort resizing, this has to be done later,
-	 * after the SHMEM_RESIZE_DONE.
-	 */
-
-	/*
-	 * Evict extra buffers when shrinking shared buffers. We need to do this
-	 * while the memory for extra buffers is still mapped i.e. before remapping
-	 * the shared memory segments to a smaller memory area.
-	 */
-	if (NBuffersOld > NBuffersPending)
-	{
-		BarrierArriveAndWait(barrier, WAIT_EVENT_SHMEM_RESIZE_START);
-
-		/*
-		 * TODO: If the buffer eviction fails for any reason, we should
-		 * gracefully rollback the shared buffer resizing and try again. But the
-		 * infrastructure to do so is not available right now. Hence just raise
-		 * a FATAL so that the system restarts.
-		 */
-		if (!EvictExtraBuffers(NBuffersPending, NBuffersOld))
-			elog(FATAL, "buffer eviction failed");
-
-		if (BarrierArriveAndWait(barrier, WAIT_EVENT_SHMEM_RESIZE_EVICT))
-			SendPostmasterSignal(PMSIGNAL_SHMEM_RESIZE);
-	}
-	else
-		if (BarrierArriveAndWait(barrier, WAIT_EVENT_SHMEM_RESIZE_START))
-			SendPostmasterSignal(PMSIGNAL_SHMEM_RESIZE);
-
-	AnonymousShmemResize();
-
-	/* The second phase means the resize has finished, SHMEM_RESIZE_DONE */
-	BarrierArriveAndWait(barrier, WAIT_EVENT_SHMEM_RESIZE_DONE);
-
-	if (MyBackendType == B_BG_WRITER)
-	{
-		/*
-		 * Before resuming regular background writer activity, adjust the
-		 * statistics collected so far.
-		 */
-		BgBufferSyncReset(NBuffersOld, NBuffers);
-	}
-
-	BarrierDetach(barrier);
 	return true;
 }
 
-/*
- * GUC assign hook for shared_buffers.
- *
- * When setting the GUC first time after starting the server, the GUC value is
- * changed immediately since there is not shared memory setup yet.
- *
- * After the shared memory is setup, changing the GUC value requires resizing and
- * reiniatializing (at least parts of) the shared memory structures related to
- * shared buffers. That's a long and complicated process.  It's recommended for
- * an assign hook to be as minimal as possible, thus we just request shared
- * memory resize and remember the previous value.
- */
-void
-assign_shared_buffers(int newval, void *extra, bool *pending)
-{
-	/*
-	 * TODO: If a backend joins while the buffer resizing is in progress or it
-	 * reads a value of shared_buffers from configuration which is different from
-	 * the value being used by existing backends, this method may not work. Need
-	 * to think of a better solution. 
-	 */
-	if (BufferBlocks)
-	{
-		elog(DEBUG1, "bufferpool is already initialized with size = %d, reinitializing it with size = %d",
-			NBuffers, newval);
-		pending_pm_shmem_resize = true;
-		*pending = true;
-		NBuffersPending = newval;
-		NBuffersOld = NBuffers;
-	}
-	else
-	{
-		elog(DEBUG1, "initializing buffer pool with size = %d", newval);
-		NBuffers = newval;
-		*pending = false;
-		pending_pm_shmem_resize = false;
-	}
-}
-
-/*
- * Test if we have somehow missed a shmem resize signal and NBuffers value
- * differs from NSharedBuffers. If yes, catchup and do resize.
- */
-void
-AdjustShmemSize(void)
-{
-	uint32 NSharedBuffers = pg_atomic_read_u32(&ShmemCtrl->NSharedBuffers);
-
-	if (NSharedBuffers != NBuffers)
-	{
-		/*
-		 * If the broadcasted shared_buffers is different from the one we see,
-		 * it could be that the backend has missed a resize signal. To avoid
-		 * any inconsistency, adjust the shared mappings, before having a
-		 * chance to access the buffer pool.
-		 */
-		ereport(LOG,
-				(errmsg("shared_buffers has been changed from %d to %d, "
-						"resize shared memory",
-						NBuffers, NSharedBuffers)));
-		NBuffers = NSharedBuffers;
-		AnonymousShmemResize();
-	}
-}
-
-/*
- * Start resizing procedure, making sure all existing processes will have
- * consistent view of shared memory size. Must be called only in postmaster.
- */
-void
-CoordinateShmemResize(void)
-{
-	elog(DEBUG1, "Coordinating shmem resize from %d to %d",
-		 NBuffersOld, NBuffers);
-	Assert(!IsUnderPostmaster);
-
-	/*
-	 * We use dynamic barrier to help dealing with backends that were spawned
-	 * during the resize.
-	 */
-	BarrierInit(&ShmemCtrl->Barrier, 0);
-
-	/*
-	 * If the value did not change, or shared memory segments are not
-	 * initialized yet, skip the resize.
-	 */
-	if (NBuffersPending == NBuffersOld)
-	{
-		elog(DEBUG1, "Skip resizing, new %d, old %d",
-			 NBuffers, NBuffersOld);
-		return;
-	}
-
-	/*
-	 * Shared memory resize requires some coordination done by postmaster,
-	 * and consists of three phases:
-	 *
-	 * - Before the resize all existing backends have the same old NBuffers.
-	 * - When resize is in progress, backends are expected to have a
-	 *   mixture of old a new values. They're not allowed to touch buffer
-	 *   pool during this time frame.
-	 * - After resize has been finished, all existing backends, that can access
-	 *   the buffer pool, are expected to have the same new value of NBuffers.
-	 *
-	 * Those phases are ensured by joining the shared barrier associated with
-	 * the procedure. Since resizing takes time, we need to take into account
-	 * that during that time:
-	 *
-	 * - New backends can be spawned. They will check status of the barrier
-	 *   early during the bootstrap, and wait until everything is over to work
-	 *   with the new NBuffers value.
-	 *
-	 * - Old backends can exit before attempting to resize. Synchronization
-	 *   used between backends relies on ProcSignalBarrier and waits for all
-	 *   participants received the message at the beginning to gather all
-	 *   existing backends.
-	 *
-	 * - Some backends might be blocked and not responsing either before or
-	 *   after receiving the message. In the first case such backend still
-	 *   have ProcSignalSlot and should be waited for, in the second case
-	 *   shared barrier will make sure we still waiting for those backends. In
-	 *   any case there is an unbounded wait.
-	 *
-	 * - Backends might join barrier in disjoint groups with some time in
-	 *   between. That means that relying only on the shared dynamic barrier is
-	 *   not enough -- it will only synchronize resize procedure withing those
-	 *   groups. That's why we wait first for all participants of ProcSignal
-	 *   mechanism who received the message.
-	 */
-	elog(DEBUG1, "Emit a barrier for shmem resizing");
-	pg_atomic_init_u64(&ShmemCtrl->Generation,
-					   EmitProcSignalBarrier(PROCSIGNAL_BARRIER_SHMEM_RESIZE));
-
-	/* To order everything after setting Generation value */
-	pg_memory_barrier();
-
-	/*
-	 * After that postmaster waits for PMSIGNAL_SHMEM_RESIZE as a sign that all
-	 * the rest of the pack has started the procedure and it can resize shared
-	 * memory as well.
-	 *
-	 * Normally we would call WaitForProcSignalBarrier here to wait until every
-	 * backend has reported on the ProcSignalBarrier. But for shared memory
-	 * resize we don't need this, as every participating backend will
-	 * synchronize on the ProcSignal barrier. In fact even if we would like to
-	 * wait here, it wouldn't be possible -- we're in the postmaster, without
-	 * any waiting infrastructure available.
-	 *
-	 * If at some point it will turn out that waiting is essential, we would
-	 * need to consider some alternatives. E.g. it could be a designated
-	 * coordination process, which is not a postmaster. Another option would be
-	 * to introduce a CoordinateShmemResize lock and allow only one process to
-	 * take it (this probably would have to be something different than
-	 * LWLocks, since they block interrupts, and coordination relies on them).
-	 */
-}
-
 /*
  * PGSharedMemoryCreate
  *
@@ -1374,7 +1061,7 @@ PGSharedMemoryCreate(AnonymousMapping *mapping,
 	void	   *memAddress;
 	PGShmemHeader *hdr;
 	struct stat statbuf;
-	Size		sysvsize, total_reserved;
+	Size		sysvsize;
 
 	/*
 	 * We use the data directory's ID info (inode and device numbers) to
@@ -1398,12 +1085,6 @@ PGSharedMemoryCreate(AnonymousMapping *mapping,
 
 	/* Prepare the mapping information */
 	mapping->shmem_size = mapping->shmem_req_size;
-	total_reserved = (Size) MaxAvailableMemory * BLCKSZ;
-	mapping->shmem_reserved = total_reserved * SHMEM_RESIZE_RATIO[mapping->shmem_segment];
-
-	/* Round up to be a multiple of BLCKSZ */
-	mapping->shmem_reserved = mapping->shmem_reserved + BLCKSZ -
-		(mapping->shmem_reserved % BLCKSZ);
 
 	if (shared_memory_type == SHMEM_TYPE_MMAP)
 	{
@@ -1666,29 +1347,6 @@ PGSharedMemoryDetach(void)
 	}
 }
 
-void
-WaitOnShmemBarrier()
-{
-	Barrier *barrier = &ShmemCtrl->Barrier;
-
-	/* Nothing to do if resizing is not started */
-	if (BarrierPhase(barrier) < SHMEM_RESIZE_START)
-		return;
-
-	BarrierAttach(barrier);
-
-	/* Otherwise wait through all available phases */
-	while (BarrierPhase(barrier) < SHMEM_RESIZE_DONE)
-	{
-		ereport(LOG, (errmsg("ProcSignal barrier is in phase %d, waiting",
-							 BarrierPhase(barrier))));
-
-		BarrierArriveAndWait(barrier, 0);
-	}
-
-	BarrierDetach(barrier);
-}
-
 void
 ShmemControlInit(void)
 {
@@ -1700,16 +1358,13 @@ ShmemControlInit(void)
 
 	if (!foundShmemCtrl)
 	{
-		/*
-		 * The barrier is missing here, it will be initialized right before
-		 * starting the resizing process as a convenient way to reset it.
-		 */
-
-		/* Initialize with the currently known value */
-		pg_atomic_init_u32(&ShmemCtrl->NSharedBuffers, NBuffers);
-
-		/* shmem_resizable should be initialized by now */
-		ShmemCtrl->Resizable = shmem_resizable;
-		ShmemCtrl->evictor_pid = 0;
+		pg_atomic_init_u32(&ShmemCtrl->targetNBuffers, 0);
+		pg_atomic_init_u32(&ShmemCtrl->activeNBuffers, 0);
+		pg_atomic_init_u32(&ShmemCtrl->transitNBuffers, 0);
+		pg_atomic_init_flag(&ShmemCtrl->resize_in_progress);
+
+		ShmemCtrl->coordinator = 0;
+		ShmemCtrl->pmwork_done = false;
+		ConditionVariableInit(&ShmemCtrl->pm_cv);
 	}
 }
